import sys
import re
tables = {'Student':['sid', 'dept', 'age'], 'Course':['cid', 'name'], 'Teacher':['tid', 'dept', 'age'], 'Grade':['sid', 'cid', 'score'], 'Teach':['cid', 'tid']}
data = {'Student':[], 'Course':[], 'Teacher':[], 'Grade':[], 'Teach':[]}
n = int(sys.stdin.readline().strip())
for _ in range(n):
    line = sys.stdin.readline().strip()
    line = line.split(' ')
    data['Student'].append({'sid':line[0], 'dept':line[1], 'age':int(line[2])})
n = int(sys.stdin.readline().strip())
for _ in range(n):
    line = sys.stdin.readline().strip()
    line = line.split(' ')
    data['Course'].append({'cid':line[0], 'name':line[1]})
n = int(sys.stdin.readline().strip())
for _ in range(n):
    line = sys.stdin.readline().strip()
    line = line.split(' ')
    data['Teacher'].append({'tid':line[0], 'dept':line[1], 'age':int(line[2])})
n = int(sys.stdin.readline().strip())
for _ in range(n):
    line = sys.stdin.readline().strip()
    line = line.split(' ')
    data['Grade'].append({'sid':line[0], 'cid':line[1], 'score':int(line[2])})
n = int(sys.stdin.readline().strip())
for _ in range(n):
    line = sys.stdin.readline().strip()
    line = line.split(' ')
    data['Teach'].append({'cid':line[0], 'tid':line[1]})
n = int(sys.stdin.readline().strip())
for _ in range(n):
    line = sys.stdin.readline().strip()
    tokens = re.findall(r'".*?"', line)
    line = re.sub(r'".*?"', r'"TOKEN!!!"', line)
    m = re.match(r'SELECT (.*) FROM (.*) WHERE (.*)', line)
    joins = []
    filters = []
    if m is None:
        m = re.match(r'SELECT (.*) FROM (.*)', line)
    else:
        ands = [x.strip() for x in m.group(3).split('AND')]
        ands = [re.match(r'(.*)(<|>|=)(.*)', x).groups() for x in ands]
        token_id = 0
        for x in ands:
            if x[2].strip().isdigit():
                filters.append((x[0].strip(), x[1], int(x[2].strip())))
            elif r'"' in x[2]:
                filters.append((x[0].strip(), x[1], tokens[token_id].strip().replace(r'"','')))
                token_id+=1
            else:
                joins.append((x[0].strip(), x[1], x[2].strip()))
    froms = {x.strip():0 for x in m.group(2).split(',')}
    froms_name = [x.strip() for x in m.group(2).split(',')]
    used_froms_set = []
    used_froms = []
    if(m.group(1) == '*'):
        selects = []
        for name in froms_name:
            selects.extend([name+'.'+x for x in tables[name]])
    else:
        selects = [x.strip() for x in m.group(1).split(',')]
    for select in selects:
        if '.' in select:
            name = select.split('.')[0].strip()
            column = select.split('.')[1].strip()
        else:
            for table,columns in tables.items():
                if select in columns and table in froms:
                    name = table
                    column = select
        used_froms_set.append(name)
    for name in froms_name:
        if name in used_froms:
            used_froms.append(name)

    items = {x:[True for i in range(len(data[x]))] if x in froms else [] for x in tables}
    for filter in filters:
        if '.' in filter[0]:
            name = filter[0].split('.')[0].strip()
            column = filter[0].split('.')[1].strip()
        else:
            for table,columns in tables.items():
                if filter[0] in columns and table in froms:
                    name = table
                    column = filter[0]
        for i in range(len(data[name])):
            if not items[name][i]:
                continue
            if filter[1] == '<':
                items[name][i] = data[name][i][column] < filter[2]
            elif filter[1] == '=':
                items[name][i] = data[name][i][column] == filter[2]
            elif filter[1] == '>':
                items[name][i] = data[name][i][column] > filter[2]
    t_items = {x:[] if x in froms else [] for x in tables}
    for key,value in items.items():
        for i in range(len(value)):
            if value[i]:
                t_items[key].append(i)
    items = t_items
    pairs = {}
    for filter in joins:
        if '.' in filter[0]:
            namel = filter[0].split('.')[0].strip()
            columnl = filter[0].split('.')[1].strip()
        else:
            for table,columns in tables.items():
                if filter[0] in columns and table in froms:
                    namel = table
                    columnl = filter[0]
        if '.' in filter[2]:
            namer = filter[2].split('.')[0].strip()
            columnr = filter[2].split('.')[1].strip()
        else:
            for table,columns in tables.items():
                if filter[2] in columns and table in froms:
                    namer = table
                    columnr = filter[2]
        for i in items[namel]:
            for j in items[namer]:
                if data[namel][i][columnl] == data[namer][j][columnr]:
                    pairs[(namel, i, namer, j)] = True
                    pairs[(namer, j, namel, i)] = True
    for i in items[froms_name[0]]:
        froms[froms_name[0]] = i
        for j in items[froms_name[1]] if len(froms_name) >= 2 else range(1):
            if len(froms_name) >= 2:
                if len(joins) != 0 and not (froms_name[0], i, froms_name[1], j) in pairs:
                    continue
                froms[froms_name[1]] = j
            for select_id,select in enumerate(selects):
                if '.' in select:
                    name = select.split('.')[0].strip()
                    column = select.split('.')[1].strip()
                else:
                    for table,columns in tables.items():
                        if select in columns and table in froms:
                            name = table
                            column = select
                print(data[name][froms[name]][column], end = ' ' if select_id < len(selects)-1 else '\n')
